import java.util.*;

int W;
int H;

float tx = 0.5;
float ty = 0.5;

float tr = 0.025;

Vector vec;

Thread thread;

int nt = 500;
int nj = 16;
Integer[] idxs;

int lastX;
int lastY;

void setup() {
  vec = new Vector();
  size(640,480);
  W = width;
  H = height;
  smooth();
  noLoop();


  for(int i = 0; i < 0; i++) {
    float [] pair = new float[2];
    pair[0] = random(1);
    pair[1] = random(1);
    vec.add(pair);
  }

  reset();
}

void reset() {
  if(thread != null) {
    thread.stop();
    thread = null;
  }

  thread = new Thread(){
    public void run() {
      while(true) {
        try {
          Thread.sleep(125);
        } 
        catch(InterruptedException ie) {
        }
        catch(ThreadDeath death) {
          break;
        }
        sample();
      }  
    }
  };
  thread.start();

  vec = new Vector();
  tx = random(0.8)+0.1;
  ty = random(0.8)+0.1;

  idxs = new Integer[nt];
  for(int i = 0; i < nt; i++) {
    idxs[i]=new Integer(i); 
  }

  Arrays.sort(idxs,new Comparator(){
    public int compare(Object a, Object b) {
      float q = 2*(noise(0.1*((Integer)a).intValue(),ty)-0.5)+0.5;
      float w = 2*(noise(0.1*((Integer)b).intValue(),ty)-0.5)+0.5;
      if(q<w) { 
        return -1; 
      } 
      else {
        return 1;
      }
    }
  }
  );

  redraw();
}

void draw () {
  boolean located = false;
  background(15,25,10);
  noFill();

  if(true) {
    noStroke();
    fill(60,50,10,128);
    ellipse(tx*W,ty*H,tr*W/2,tr*H/2);
    fill(0,0,0,32);
    ellipse(tx*W,ty*H,tr*W*2,tr*H*2);
  }


  stroke(255);
  for(int i = 0; i<vec.size(); i++) {
    float [] pair = (float[])vec.get(i);
    float x = pair[0];
    float y = pair[1];

    float qs = 4;
    float qn = 4.0*sqrt((tx-x)*(tx-x)+(ty-y)*(ty-y));
    float qx = x + qn*(noise(qs*x)-noise(qs*tx));
    float qy = y + qn*(noise(qs*y)-noise(qs*ty));

    float vl = sqrt((qx-tx)*(qx-tx)+(qy-ty)*(qy-ty));
    float vk = 0.01;
    float vx = vk*(tx-qx)/vl;
    float vy = vk*(ty-qy)/vl;
    strokeWeight(5.0);
    point(x*W,y*H);
    strokeWeight(1.0);
    line(x*W,y*H,(x+vx)*W,(y+vy)*H);
    if(sqrt((tx-x)*(tx-x)+(ty-y)*(ty-y)) < tr) {
      located = true;
    }
  }

  if(located) {
    strokeWeight(2.0);
    stroke(255,255,0);
    ellipse(tx*W,ty*H,tr*W,tr*H);
  }

  for(int i = 0; i < nt; i++) {
    float x = 2*(noise(0.4*i,tx)-0.5)+0.5;
    float y = 2*(noise(0.1*i,ty)-0.5)+0.5;

    stroke(0,0,0,64);
    strokeWeight(8.0);
    point((x-tr)*W,(y+tr/2)*H);
    strokeWeight(2.0);
    line(x*W,(y+tr)*H,(x-tr)*W,(y+tr/2)*H);
  }


  if(idxs != null) {
    for(int i = 0; i < nt; i++) {
      int ii = idxs[i].intValue();
      float x = 2*(noise(0.4*ii,tx)-0.5)+0.5;
      float y = 2*(noise(0.1*ii,ty)-0.5)+0.5;

      strokeWeight(2.0);
      stroke(60,50,10);
      line(x*W,y*H,x*W,(y+tr)*H);

      strokeWeight(4.0);
      for(int j =0; j < nj; j++) {
        float rj = tr;
        float jx = rj*(noise(20*i,j,tx)-0.5);
        float jy = rj*(noise(30*i,j,ty)-0.5);
        stroke(0,512*(nj-j)/nj,0,64);
        point((x+jx)*W,(y+jy)*H);
      }
    }
  }
}

void sample() {
  if(abs((lastX-mouseX)/(float)W) > tr*2 || abs((lastY-mouseY)/(float)H) > tr*2) {
    lastX = mouseX;
    lastY = mouseY;   


    float [] pair = new float[2];
    pair[0] = (float)mouseX/W;
    pair[1] = (float)mouseY/H;
    vec.add(pair);
    redraw();
  }
}

void mouseClicked() {  
  float [] pair = new float[2];
  pair[0] = (float)mouseX/W;
  pair[1] = (float)mouseY/H;
  vec.add(pair);
  if(sqrt((tx-pair[0])*(tx-pair[0])+(ty-pair[1])*(ty-pair[1])) < tr) {
    reset();
  } 
  else {
    redraw();
  }
}

void keyPressed() {
  reset();
  redraw(); 
}











